<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImpUserAddress ArrayType
 * @subpackage Arrays
 */
class ArrayOfImpUserAddress extends AbstractStructArrayBase
{
    /**
     * The ImpUserAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ImpUserAddress[]
     */
    public $ImpUserAddress;
    /**
     * Constructor method for ArrayOfImpUserAddress
     * @uses ArrayOfImpUserAddress::setImpUserAddress()
     * @param \StructType\ImpUserAddress[] $impUserAddress
     */
    public function __construct(array $impUserAddress = array())
    {
        $this
            ->setImpUserAddress($impUserAddress);
    }
    /**
     * Get ImpUserAddress value
     * @return \StructType\ImpUserAddress[]|null
     */
    public function getImpUserAddress()
    {
        return $this->ImpUserAddress;
    }
    /**
     * This method is responsible for validating the values passed to the setImpUserAddress method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImpUserAddress method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImpUserAddressForArrayConstraintsFromSetImpUserAddress(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImpUserAddressImpUserAddressItem) {
            // validation for constraint: itemType
            if (!$arrayOfImpUserAddressImpUserAddressItem instanceof \StructType\ImpUserAddress) {
                $invalidValues[] = is_object($arrayOfImpUserAddressImpUserAddressItem) ? get_class($arrayOfImpUserAddressImpUserAddressItem) : sprintf('%s(%s)', gettype($arrayOfImpUserAddressImpUserAddressItem), var_export($arrayOfImpUserAddressImpUserAddressItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImpUserAddress property can only contain items of type \StructType\ImpUserAddress, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImpUserAddress value
     * @throws \InvalidArgumentException
     * @param \StructType\ImpUserAddress[] $impUserAddress
     * @return \ArrayType\ArrayOfImpUserAddress
     */
    public function setImpUserAddress(array $impUserAddress = array())
    {
        // validation for constraint: array
        if ('' !== ($impUserAddressArrayErrorMessage = self::validateImpUserAddressForArrayConstraintsFromSetImpUserAddress($impUserAddress))) {
            throw new \InvalidArgumentException($impUserAddressArrayErrorMessage, __LINE__);
        }
        $this->ImpUserAddress = $impUserAddress;
        return $this;
    }
    /**
     * Add item to ImpUserAddress value
     * @throws \InvalidArgumentException
     * @param \StructType\ImpUserAddress $item
     * @return \ArrayType\ArrayOfImpUserAddress
     */
    public function addToImpUserAddress(\StructType\ImpUserAddress $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImpUserAddress) {
            throw new \InvalidArgumentException(sprintf('The ImpUserAddress property can only contain items of type \StructType\ImpUserAddress, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImpUserAddress[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImpUserAddress|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImpUserAddress|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImpUserAddress|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImpUserAddress|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImpUserAddress|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImpUserAddress
     */
    public function getAttributeName()
    {
        return 'ImpUserAddress';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfImpUserAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
